#include <mpi.h>
#include <stdio.h>
#include <iostream>
#include <sstream>
#include <unistd.h>
#include <limits.h>
#include <thread>
using namespace std;

int main(int argc, char** argv) {
    // Initialize the MPI environment
    MPI_Init(NULL, NULL);

    // Get the number of processes
    int size;
    MPI_Comm_size(MPI_COMM_WORLD, &size);

    // Get the rank of the process
    int rank;
    MPI_Comm_rank(MPI_COMM_WORLD, &rank);

    // Get the name of the processor
    char processor_name[MPI_MAX_PROCESSOR_NAME];
    int name_len;
    MPI_Get_processor_name(processor_name, &name_len);
    
    unsigned num_threads = std::thread::hardware_concurrency();

    ostringstream msg;
    msg << "Hello from " << processor_name << ". I am rank " << rank
        << " out of "<<  size << ", "
        << "SLURM booked me  " <<  std::getenv("SLURM_CPUS_PER_TASK") << " cpus.\n";

    cout << msg.str();

    // Finalize the MPI environment.
    MPI_Finalize();
}

